library(uoptr)
library(adr)

a <- 1
b <- 100

f <- obj <- function(x) {
    r  <- (a - x[[1]])^2 + b * (x[[2]] - x[[1]]^2)^2
    r
}

v0  <- array(rnorm(1:2)*10, c(1, 2))

g <- function(x) {
    adrDiffFD(f, list(x))
                                        #        r <- adrDiffRev(f, list(x))
}

H <- function(x) {
    adrHessFD(f, list(x))
                                        #        r <- adrHessian(f, list(x))
}

output <- function(f, status) {
    cat(paste(names(status), status, collapse=', ', sep='='))
    cat('\n')
    0
}

opts <- list()

vs <- uopt(v0, f, g, H, s = output, options = opts)

show(vs)

fs <- obj(vs)

show(fs)
