import numpy as np

np.set_printoptions(linewidth=125)

from rosenN import rosenNs, rosenN, rosenNObj, rosenOutput

def rosenNJac(x, y, J, *args):
    rosenNObj(x, y)
    h = 1e-8
    y1 = y.copy()
    y2 = y.copy()
    v = x.copy()
    for i in range(x.size):
        v[i] = x[i] - h
        rosenNObj(v, y1)
        v[i] = x[i] + h
        rosenNObj(v, y2)
        v[i] = x[i]
        J[:,i] = (y2 - y1) / (2*h)

def rosenNJacv(x, y, v, Jv, *args):
    rosenNObj(x, y)
    v = v.reshape((x.size,))
    h = 1e-8
    y1 = y.copy()
    y2 = y.copy()
    w = x - v*h
    rosenNObj(w, y1)
    w = x + v*h
    rosenNObj(w, y2)
    Jv[:,0] = (y2 - y1) / (2*h)

def rosenNJacTv(x, y, v, Jv, *args):
    J = np.ndarray((y.size, x.size), order='F')
    rosenNJac(x, y, J)
    v = v.reshape(1,y.size)
    Jv[0,:] = np.matmul(v, J)
