library(uoptr)
library(adr)
library(testthat)

context('test-sphereN')

test_that("Sphere ND problem", {

    f <- function(x) {
        sqrt(sum(x^2))
    }

    N <- 120

    v0  <- array(rnorm(1:N)*1000, c(1, N))

    f0 <- f(v0)

    g <- function(x) {
        adrDiffRev(f, list(x))
    }

    H <- function(x) {
        adrHessian(f, list(x))
    }

    opts <- list(sdirs=0x18, enableFallback=1, wolcheck=0)

    vs <- uopt(v0, f, g, H, options = opts)

    vsinfo <- attr(vs, 'info')
    vsv <- c(vs)

    ## show(vsv)

    fs <- f(vs)

    ##    show(fs)

    ## shownlist(vsinfo$last)
    ## shownlist(vsinfo$exit)

    expect_true(vsinfo$status == 0)
    expect_true(norm(vs, "2") < 1e-6)

})
